﻿using Hotline.Application.Snapshot;
using Hotline.Repository.SqlSugar.Extensions;
using Hotline.Share.Dtos;
using Hotline.Share.Dtos.Snapshot;
using Hotline.Share.Tools;
using Hotline.Snapshot.Interfaces;
using Microsoft.AspNetCore.Mvc;

namespace Hotline.Api.Controllers.Snapshot;

/// <summary>
/// 随手拍行业管理接口
/// </summary>
public class IndustryController : BaseController
{
    private readonly IIndustryRepository _industryRepository;
    private readonly IIndustryApplication _industryApplication;

    public IndustryController(IIndustryRepository industryRepository, IIndustryApplication industryApplication)
    {
        _industryRepository = industryRepository;
        _industryApplication = industryApplication;
    }

    /// <summary>
    /// 新增行业
    /// </summary>
    /// <returns></returns>
    [HttpPost]
    public async Task<string> AddIndustry([FromBody] AddIndustryDto dto)
        => await _industryApplication.AddIndustryAsync(dto, HttpContext.RequestAborted);

    /// <summary>
    /// 获取行业集合
    /// </summary>
    /// <returns></returns>
    [HttpGet("industry")]
    public async Task<PagedDto<IndustryItemsOutDto>> GetIndustryAsync([FromQuery] IndustryListInDto dto)
        => (await _industryApplication.GetIndustres(dto).ToPagedListAsync(dto, HttpContext.RequestAborted)).ToPaged();
}
